<template>
  <div>{{ duration }}</div>
</template>

<script lang="ts">
import Vue from "vue";

export default Vue.extend({
  props: ["time"],
  methods: {
    zeroPad(num: number) {
      if (num >= 10) {
        return num;
      }
      return `0${num}`;
    },
  },
  data() {
    return {
      now: new Date(),
      timer: undefined as undefined | number,
    };
  },
  computed: {
    duration() {
      const milliseconds = this.time - this.now.getTime();
      const seconds = Math.floor(milliseconds / 1000);
      const minutes = Math.floor(seconds / 60);

      if (minutes <= 0 && seconds <= 0) return "0:00";

      return `${minutes}:${this.zeroPad(seconds % 60)}`;
    },
  },
  created() {
    var self = this;
    this.timer = setInterval(function () {
      self.now = new Date();
    }, 1 * 1000);
  },
  beforeDestroy() {
    clearTimeout(this.timer);
  },
});
</script>
